]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
Merge branch 'ls/no-double-utf8-author-name' of ../git-gui into ls/git-gui-no-double...
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
85b81b35
JK
47# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
2006f0ad
RR
52################################################################
53# It appears that people try to run tests without building...
54"$GIT_BUILD_DIR/git" >/dev/null
55if test $? != 1
56then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59fi
60
3c8f12c9
JH
61. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62export PERL_PATH SHELL_PATH
63
4cde519f
RR
64# if --tee was passed, write the output not only to the terminal, but
65# additionally to the file test-results/$BASENAME.out, too.
66case "$GIT_TEST_TEE_STARTED, $* " in
67done,*)
68 # do not redirect again
69 ;;
452320f1 70*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
71 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
73
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
4cde519f 83 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
452320f1 84 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 85 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
86 exit
87 ;;
88esac
89
e1970ce4 90# For repeatability, reset the environment to known value.
d5c1b7c2 91# TERM is sanitized below, after saving color control sequences.
e1970ce4 92LANG=C
899460f3 93LC_ALL=C
d9bdd39e 94PAGER=cat
e1970ce4 95TZ=UTC
d5c1b7c2 96export LANG LC_ALL PAGER TZ
8ff99e74 97EDITOR=:
661bfd13
SL
98# A call to "unset" with no arguments causes at least Solaris 10
99# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
100# deriving from the command substitution clustered with the other
101# ones.
3c8f12c9 102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 103 my @env = keys %ENV;
730477f1
JL
104 my $ok = join("|", qw(
105 TRACE
106 DEBUG
730477f1
JL
107 TEST
108 .*_TEST
109 PROVE
110 VALGRIND
ac001282 111 UNZIP
edb54081 112 PERF_
e2a0ccc0 113 CURL_VERBOSE
4527aa10 114 TRACE_CURL
730477f1
JL
115 ));
116 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
117 print join("\n", @vars);
118')
5adf84eb 119unset XDG_CONFIG_HOME
8bade1e1 120unset GITPERLLIB
29e55cd5
JH
121GIT_AUTHOR_EMAIL=author@example.com
122GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
123GIT_COMMITTER_EMAIL=committer@example.com
124GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 125GIT_MERGE_VERBOSITY=5
f8246281
JH
126GIT_MERGE_AUTOEDIT=no
127export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
128export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
129export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 130export EDITOR
e1970ce4 131
124647c4
KB
132# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
133GIT_TRACE_BARE=1
134export GIT_TRACE_BARE
135
5d9fc888
TG
136if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
137then
138 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
139 export GIT_INDEX_VERSION
140fi
141
a731fa91
EP
142# Add libc MALLOC and MALLOC_PERTURB test
143# only if we are not executing the test with valgrind
1b3185fc 144if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 145 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
146then
147 setup_malloc_check () {
148 : nothing
149 }
150 teardown_malloc_check () {
151 : nothing
152 }
153else
154 setup_malloc_check () {
155 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
156 export MALLOC_CHECK_ MALLOC_PERTURB_
157 }
158 teardown_malloc_check () {
159 unset MALLOC_CHECK_ MALLOC_PERTURB_
160 }
161fi
a731fa91 162
886a3907
JH
163# Protect ourselves from common misconfiguration to export
164# CDPATH into the environment
165unset CDPATH
166
5565f47c 167unset GREP_OPTIONS
ac001282 168unset UNZIP
5565f47c 169
3d5c0cc9 170case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1711|2|true)
025232e8 172 GIT_TRACE=4
1c0cc756 173 ;;
6ce4e61f
CC
174esac
175
cd3c095c
JH
176# Convenience
177#
5555a2aa 178# A regexp to match 5, 35 and 40 hexdigits
cd3c095c 179_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
5555a2aa
CB
180_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
181_x40="$_x35$_x05"
cd3c095c 182
3749fde5
JH
183# Zero SHA-1
184_z40=0000000000000000000000000000000000000000
185
f9e7d9f8 186EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 187EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 188
3f4ab627
JH
189# Line feed
190LF='
191'
192
a42643aa
JK
193# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
194# when case-folding filenames
195u200c=$(printf '\342\200\214')
196
5555a2aa 197export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
342e9ef2 198
e1970ce4
JH
199# Each test should start with something like this, after copyright notices:
200#
201# test_description='Description of this test...
202# This test checks if command xyzzy does the right thing...
203# '
204# . ./test-lib.sh
d5c1b7c2 205test "x$TERM" != "xdumb" && (
ca92a660
RH
206 test -t 1 &&
207 tput bold >/dev/null 2>&1 &&
208 tput setaf 1 >/dev/null 2>&1 &&
209 tput sgr0 >/dev/null 2>&1
210 ) &&
211 color=t
e1970ce4 212
e1970ce4
JH
213while test "$#" -ne 0
214do
215 case "$1" in
216 -d|--d|--de|--deb|--debu|--debug)
217 debug=t; shift ;;
886856ab
JH
218 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
219 immediate=t; shift ;;
5e2c08c6 220 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 221 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
222 -r)
223 shift; test "$#" -ne 0 || {
224 echo 'error: -r requires an argument' >&2;
225 exit 1;
226 }
227 run_list=$1; shift ;;
228 --run=*)
0ff74101 229 run_list=${1#--*=}; shift ;;
e1970ce4 230 -h|--h|--he|--hel|--help)
570f3226 231 help=t; shift ;;
e1970ce4
JH
232 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
233 verbose=t; shift ;;
ff09af3f 234 --verbose-only=*)
0ff74101 235 verbose_only=${1#--*=}
ff09af3f 236 shift ;;
1ece1274 237 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
238 # Ignore --quiet under a TAP::Harness. Saying how many tests
239 # passed without the ok/not ok details is always an error.
240 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
241 --with-dashes)
242 with_dashes=t; shift ;;
55db1df0 243 --no-color)
faa4bc35 244 color=; shift ;;
4e1be63c 245 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
246 valgrind=memcheck
247 shift ;;
248 --valgrind=*)
0ff74101 249 valgrind=${1#--*=}
952af351 250 shift ;;
5dfc368f 251 --valgrind-only=*)
0ff74101 252 valgrind_only=${1#--*=}
5dfc368f 253 shift ;;
44138559
JS
254 --tee)
255 shift ;; # was handled already
f423ef5f 256 --root=*)
0ff74101 257 root=${1#--*=}
f423ef5f 258 shift ;;
bb79af9d
JK
259 --chain-lint)
260 GIT_TEST_CHAIN_LINT=1
261 shift ;;
262 --no-chain-lint)
263 GIT_TEST_CHAIN_LINT=0
264 shift ;;
a136f6d8
JK
265 -x)
266 trace=t
267 verbose=t
268 shift ;;
452320f1
JK
269 --verbose-log)
270 verbose_log=t
271 shift ;;
e1970ce4 272 *)
1f729dca 273 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
274 esac
275done
276
26a07309 277if test -n "$valgrind_only"
5dfc368f
TR
278then
279 test -z "$valgrind" && valgrind=memcheck
280 test -z "$verbose" && verbose_only="$valgrind_only"
281elif test -n "$valgrind"
282then
88c6e9d3 283 test -z "$verbose_log" && verbose=t
5dfc368f 284fi
952af351 285
ca92a660
RH
286if test -n "$color"
287then
d5c1b7c2
RH
288 # Save the color control sequences now rather than run tput
289 # each time say_color() is called. This is done for two
290 # reasons:
291 # * TERM will be changed to dumb
292 # * HOME will be changed to a temporary directory and tput
293 # might need to read ~/.terminfo from the original HOME
294 # directory to get the control sequences
295 # Note: This approach assumes the control sequences don't end
296 # in a newline for any terminal of interest (command
297 # substitutions strip trailing newlines). Given that most
298 # (all?) terminals in common use are related to ECMA-48, this
299 # shouldn't be a problem.
300 say_color_error=$(tput bold; tput setaf 1) # bold red
301 say_color_skip=$(tput setaf 4) # blue
302 say_color_warn=$(tput setaf 3) # brown/yellow
303 say_color_pass=$(tput setaf 2) # green
304 say_color_info=$(tput setaf 6) # cyan
305 say_color_reset=$(tput sgr0)
306 say_color_="" # no formatting for normal text
ca92a660 307 say_color () {
d5c1b7c2
RH
308 test -z "$1" && test -n "$quiet" && return
309 eval "say_color_color=\$say_color_$1"
ca92a660 310 shift
d5c1b7c2 311 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
312 }
313else
314 say_color() {
315 test -z "$1" && test -n "$quiet" && return
316 shift
317 printf "%s\n" "$*"
318 }
319fi
320
d5c1b7c2
RH
321TERM=dumb
322export TERM
323
55db1df0
PH
324error () {
325 say_color error "error: $*"
6e7b5aaf 326 GIT_EXIT_OK=t
55db1df0
PH
327 exit 1
328}
329
330say () {
331 say_color info "$*"
332}
333
614fe015
JK
334if test -n "$HARNESS_ACTIVE"
335then
336 if test "$verbose" = t || test -n "$verbose_only"
337 then
338 printf 'Bail out! %s\n' \
339 'verbose mode forbidden under TAP harness; try --verbose-log'
340 exit 1
341 fi
342fi
343
570f3226
MB
344test "${test_description}" != "" ||
345error "Test script did not set test_description."
346
347if test "$help" = "t"
348then
cb1aefda 349 printf '%s\n' "$test_description"
570f3226
MB
350 exit 0
351fi
352
4d9d62fa 353exec 5>&1
781f76b1 354exec 6<&0
4ecae3c8 355exec 7>&2
452320f1
JK
356if test "$verbose_log" = "t"
357then
358 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
359elif test "$verbose" = "t"
e1970ce4
JH
360then
361 exec 4>&2 3>&1
362else
363 exec 4>/dev/null 3>/dev/null
364fi
365
d88785e4
JK
366# Send any "-x" output directly to stderr to avoid polluting tests
367# which capture stderr. We can do this unconditionally since it
368# has no effect if tracing isn't turned on.
369#
370# Note that this sets up the trace fd as soon as we assign the variable, so it
371# must come after the creation of descriptor 4 above. Likewise, we must never
372# unset this, as it has the side effect of closing descriptor 4, which we
373# use to show verbose tests to the user.
374#
375# Note also that we don't need or want to export it. The tracing is local to
376# this shell, and we would not want to influence any shells we exec.
377BASH_XTRACEFD=4
378
e1970ce4
JH
379test_failure=0
380test_count=0
41ac414e
JH
381test_fixed=0
382test_broken=0
2d84e9fb 383test_success=0
e1970ce4 384
d998bd4a
ÆAB
385test_external_has_tap=0
386
faa4bc35 387die () {
6e7b5aaf
CB
388 code=$?
389 if test -n "$GIT_EXIT_OK"
390 then
391 exit $code
392 else
393 echo >&5 "FATAL: Unexpected exit with code $code"
394 exit 1
395 fi
faa4bc35
CB
396}
397
6e7b5aaf 398GIT_EXIT_OK=
35641310 399trap 'die' EXIT
da706545 400trap 'exit $?' INT
41184273 401
12a29b1a
TR
402# The user-facing functions are loaded from a separate file so that
403# test_perf subshells can have them too
3c8f12c9 404. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 405
886856ab 406# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 407# the test_expect_* functions instead.
886856ab
JH
408
409test_ok_ () {
d5d9de1b 410 test_success=$(($test_success + 1))
633fe50a 411 say_color "" "ok $test_count - $@"
e1970ce4
JH
412}
413
886856ab 414test_failure_ () {
d5d9de1b 415 test_failure=$(($test_failure + 1))
633fe50a 416 say_color error "not ok $test_count - $1"
bf0dd8a8 417 shift
cb1aefda 418 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 419 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
420}
421
41ac414e 422test_known_broken_ok_ () {
41ac414e 423 test_fixed=$(($test_fixed+1))
633fe50a 424 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
425}
426
427test_known_broken_failure_ () {
41ac414e 428 test_broken=$(($test_broken+1))
633fe50a 429 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 430}
886856ab
JH
431
432test_debug () {
8e832ebc 433 test "$debug" = "" || eval "$1"
e1970ce4
JH
434}
435
e6a6ddc9
TR
436match_pattern_list () {
437 arg="$1"
438 shift
439 test -z "$*" && return 1
440 for pattern_
441 do
442 case "$arg" in
443 $pattern_)
444 return 0
445 esac
446 done
447 return 1
448}
449
0445e6f0
IB
450match_test_selector_list () {
451 title="$1"
452 shift
453 arg="$1"
454 shift
455 test -z "$1" && return 0
456
457 # Both commas and whitespace are accepted as separators.
458 OLDIFS=$IFS
459 IFS=' ,'
460 set -- $1
461 IFS=$OLDIFS
462
463 # If the first selector is negative we include by default.
464 include=
465 case "$1" in
466 !*) include=t ;;
467 esac
468
469 for selector
470 do
471 orig_selector=$selector
472
473 positive=t
474 case "$selector" in
475 !*)
476 positive=
477 selector=${selector##?}
478 ;;
479 esac
480
481 test -z "$selector" && continue
482
483 case "$selector" in
484 *-*)
485 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
486 then
487 echo "error: $title: invalid non-numeric in range" \
488 "start: '$orig_selector'" >&2
489 exit 1
490 fi
491 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
492 then
493 echo "error: $title: invalid non-numeric in range" \
494 "end: '$orig_selector'" >&2
495 exit 1
496 fi
497 ;;
498 *)
499 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
500 then
501 echo "error: $title: invalid non-numeric in test" \
502 "selector: '$orig_selector'" >&2
503 exit 1
504 fi
505 esac
506
507 # Short cut for "obvious" cases
508 test -z "$include" && test -z "$positive" && continue
509 test -n "$include" && test -n "$positive" && continue
510
511 case "$selector" in
512 -*)
513 if test $arg -le ${selector#-}
514 then
515 include=$positive
516 fi
517 ;;
518 *-)
519 if test $arg -ge ${selector%-}
520 then
521 include=$positive
522 fi
523 ;;
524 *-*)
525 if test ${selector%%-*} -le $arg \
526 && test $arg -le ${selector#*-}
527 then
528 include=$positive
529 fi
530 ;;
531 *)
532 if test $arg -eq $selector
533 then
534 include=$positive
535 fi
536 ;;
537 esac
538 done
539
540 test -n "$include"
541}
542
ff09af3f
TR
543maybe_teardown_verbose () {
544 test -z "$verbose_only" && return
545 exec 4>/dev/null 3>/dev/null
546 verbose=
547}
548
549last_verbose=t
550maybe_setup_verbose () {
551 test -z "$verbose_only" && return
26a07309 552 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
553 then
554 exec 4>&2 3>&1
555 # Emit a delimiting blank line when going from
556 # non-verbose to verbose. Within verbose mode the
557 # delimiter is printed by test_expect_*. The choice
558 # of the initial $last_verbose is such that before
559 # test 1, we do not print it.
560 test -z "$last_verbose" && echo >&3 ""
561 verbose=t
562 else
563 exec 4>/dev/null 3>/dev/null
564 verbose=
565 fi
566 last_verbose=$verbose
567}
568
5dfc368f
TR
569maybe_teardown_valgrind () {
570 test -z "$GIT_VALGRIND" && return
571 GIT_VALGRIND_ENABLED=
572}
573
574maybe_setup_valgrind () {
575 test -z "$GIT_VALGRIND" && return
26a07309 576 if test -z "$valgrind_only"
5dfc368f
TR
577 then
578 GIT_VALGRIND_ENABLED=t
579 return
580 fi
581 GIT_VALGRIND_ENABLED=
582 if match_pattern_list $test_count $valgrind_only
583 then
584 GIT_VALGRIND_ENABLED=t
585 fi
586}
587
9b5fe78b
JK
588want_trace () {
589 test "$trace" = t && test "$verbose" = t
590}
591
a136f6d8
JK
592# This is a separate function because some tests use
593# "return" to end a test_expect_success block early
594# (and we want to make sure we run any cleanup like
595# "set +x").
596test_eval_inner_ () {
597 # Do not add anything extra (including LF) after '$*'
598 eval "
9b5fe78b 599 want_trace && set -x
a136f6d8
JK
600 $*"
601}
602
a7c58f28 603test_eval_ () {
a136f6d8
JK
604 # We run this block with stderr redirected to avoid extra cruft
605 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
606 # the shell from printing the "set +x" to turn it off (nor the saving
607 # of $? before that). But we can make sure that the output goes to
608 # /dev/null.
609 #
610 # The test itself is run with stderr put back to &4 (so either to
611 # /dev/null, or to the original stderr if --verbose was used).
612 {
613 test_eval_inner_ "$@" </dev/null >&3 2>&4
614 test_eval_ret_=$?
9b5fe78b 615 if want_trace
a136f6d8
JK
616 then
617 set +x
618 if test "$test_eval_ret_" != 0
619 then
620 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
621 fi
622 fi
623 } 2>/dev/null
624 return $test_eval_ret_
a7c58f28
JN
625}
626
4d9d62fa 627test_run_ () {
b6b0afdc 628 test_cleanup=:
b586744a 629 expecting_failure=$2
bb79af9d 630
92b269f5 631 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
632 # turn off tracing for this test-eval, as it simply creates
633 # confusing noise in the "-x" output
634 trace_tmp=$trace
635 trace=
bb79af9d
JK
636 # 117 is magic because it is unlikely to match the exit
637 # code of other programs
99a64e4b
JH
638 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
639 then
640 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 641 fi
2a01ef8c 642 trace=$trace_tmp
bb79af9d
JK
643 fi
644
a57397b0 645 setup_malloc_check
a7c58f28 646 test_eval_ "$1"
b6b0afdc 647 eval_ret=$?
a57397b0 648 teardown_malloc_check
b586744a 649
a136f6d8
JK
650 if test -z "$immediate" || test $eval_ret = 0 ||
651 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 652 then
1b3185fc 653 setup_malloc_check
a7c58f28 654 test_eval_ "$test_cleanup"
1b3185fc 655 teardown_malloc_check
b586744a 656 fi
1c0cc756
RJ
657 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
658 then
57e1538a
ÆAB
659 echo ""
660 fi
aa0bcf96 661 return "$eval_ret"
4d9d62fa
PR
662}
663
ae75342c 664test_start_ () {
8586f98b 665 test_count=$(($test_count+1))
ff09af3f 666 maybe_setup_verbose
5dfc368f 667 maybe_setup_valgrind
ae75342c
TR
668}
669
670test_finish_ () {
671 echo >&3 ""
5dfc368f 672 maybe_teardown_valgrind
ff09af3f 673 maybe_teardown_verbose
ae75342c
TR
674}
675
676test_skip () {
04ece593 677 to_skip=
ef2ac68d 678 skipped_reason=
e6a6ddc9
TR
679 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
680 then
681 to_skip=t
ef2ac68d 682 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 683 fi
05236a5e
JN
684 if test -z "$to_skip" && test -n "$test_prereq" &&
685 ! test_have_prereq "$test_prereq"
a7bb3940
JS
686 then
687 to_skip=t
ef2ac68d 688
07431fc8 689 of_prereq=
05236a5e 690 if test "$missing_prereq" != "$test_prereq"
07431fc8 691 then
05236a5e 692 of_prereq=" of $test_prereq"
07431fc8 693 fi
ef2ac68d
IB
694 skipped_reason="missing $missing_prereq${of_prereq}"
695 fi
0445e6f0
IB
696 if test -z "$to_skip" && test -n "$run_list" &&
697 ! match_test_selector_list '--run' $test_count "$run_list"
698 then
699 to_skip=t
700 skipped_reason="--run"
701 fi
07431fc8 702
ef2ac68d
IB
703 case "$to_skip" in
704 t)
633fe50a 705 say_color skip >&3 "skipping test: $@"
ef2ac68d 706 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
707 : true
708 ;;
709 *)
710 false
711 ;;
712 esac
713}
714
342e9ef2
TR
715# stub; perf-lib overrides it
716test_at_end_hook_ () {
717 :
718}
719
e1970ce4 720test_done () {
6e7b5aaf 721 GIT_EXIT_OK=t
2d84e9fb 722
1c0cc756
RJ
723 if test -z "$HARNESS_ACTIVE"
724 then
342e9ef2 725 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 726 mkdir -p "$test_results_dir"
dd78478f 727 base=${0##*/}
5c885c1b 728 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 729
5c885c1b 730 cat >"$test_results_path" <<-EOF
c54e6be7
ML
731 total $test_count
732 success $test_success
733 fixed $test_fixed
734 broken $test_broken
735 failed $test_failure
736
737 EOF
8ef1abe5 738 fi
41ac414e
JH
739
740 if test "$test_fixed" != 0
741 then
633fe50a 742 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
743 fi
744 if test "$test_broken" != 0
745 then
633fe50a 746 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
747 fi
748 if test "$test_broken" != 0 || test "$test_fixed" != 0
749 then
750 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
751 msg="remaining $test_remaining test(s)"
11d54b8b 752 else
b73d9a23 753 test_remaining=$test_count
11d54b8b 754 msg="$test_count test(s)"
41ac414e 755 fi
e1970ce4 756 case "$test_failure" in
10b94e28 757 0)
1c0cc756
RJ
758 if test $test_external_has_tap -eq 0
759 then
b73d9a23 760 if test $test_remaining -gt 0
d87bd7c1 761 then
633fe50a 762 say_color pass "# passed all $msg"
d87bd7c1 763 fi
c7018be5
JH
764
765 # Maybe print SKIP message
766 test -z "$skip_all" || skip_all="# SKIP $skip_all"
767 case "$test_count" in
768 0)
769 say "1..$test_count${skip_all:+ $skip_all}"
770 ;;
771 *)
772 test -z "$skip_all" ||
773 say_color warn "$skip_all"
774 say "1..$test_count"
775 ;;
776 esac
d998bd4a 777 fi
abc5d372 778
06478dab 779 if test -z "$debug"
4d0912a2 780 then
06478dab 781 test -d "$TRASH_DIRECTORY" ||
4d0912a2 782 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 783
06478dab
JH
784 cd "$TRASH_DIRECTORY/.." &&
785 rm -fr "$TRASH_DIRECTORY" ||
4d0912a2 786 error "Tests passed but test cleanup failed; aborting"
4d0912a2 787 fi
342e9ef2
TR
788 test_at_end_hook_
789
e1970ce4
JH
790 exit 0 ;;
791
792 *)
1c0cc756
RJ
793 if test $test_external_has_tap -eq 0
794 then
633fe50a
TR
795 say_color error "# failed $test_failure among $msg"
796 say "1..$test_count"
d998bd4a 797 fi
5099b99d 798
e1970ce4
JH
799 exit 1 ;;
800
801 esac
802}
803
e4597aae 804if test -n "$valgrind"
4e1be63c 805then
4e1be63c
JS
806 make_symlink () {
807 test -h "$2" &&
808 test "$1" = "$(readlink "$2")" || {
809 # be super paranoid
810 if mkdir "$2".lock
811 then
812 rm -f "$2" &&
813 ln -s "$1" "$2" &&
814 rm -r "$2".lock
815 else
816 while test -d "$2".lock
817 do
818 say "Waiting for lock on $2."
819 sleep 1
820 done
821 fi
822 }
823 }
824
825 make_valgrind_symlink () {
36bfb0e5 826 # handle only executables, unless they are shell libraries that
11d62145 827 # need to be in the exec-path.
36bfb0e5 828 test -x "$1" ||
11d62145 829 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 830 return;
4e1be63c
JS
831
832 base=$(basename "$1")
28fab7b2
RS
833 case "$base" in
834 test-*)
835 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
836 ;;
837 *)
838 symlink_target="$GIT_BUILD_DIR/$base"
839 ;;
840 esac
4e1be63c
JS
841 # do not override scripts
842 if test -x "$symlink_target" &&
843 test ! -d "$symlink_target" &&
844 test "#!" != "$(head -c 2 < "$symlink_target")"
845 then
846 symlink_target=../valgrind.sh
847 fi
efd92ffd
JS
848 case "$base" in
849 *.sh|*.perl)
850 symlink_target=../unprocessed-script
851 esac
4e1be63c
JS
852 # create the link, or replace it if it is out of date
853 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
854 }
855
26a07309
TR
856 # override all git executables in TEST_DIRECTORY/..
857 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
858 mkdir -p "$GIT_VALGRIND"/bin
503e2241 859 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
860 do
861 make_valgrind_symlink $file
862 done
863 # special-case the mergetools loadables
864 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
865 OLDIFS=$IFS
866 IFS=:
867 for path in $PATH
868 do
869 ls "$path"/git-* 2> /dev/null |
870 while read file
ad0e6233 871 do
26a07309 872 make_valgrind_symlink "$file"
ad0e6233 873 done
26a07309
TR
874 done
875 IFS=$OLDIFS
4e1be63c
JS
876 PATH=$GIT_VALGRIND/bin:$PATH
877 GIT_EXEC_PATH=$GIT_VALGRIND/bin
878 export GIT_VALGRIND
952af351
TR
879 GIT_VALGRIND_MODE="$valgrind"
880 export GIT_VALGRIND_MODE
5dfc368f 881 GIT_VALGRIND_ENABLED=t
26a07309 882 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 883 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
884elif test -n "$GIT_TEST_INSTALLED"
885then
e4597aae
MO
886 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
887 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 888 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
889 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
890else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 891 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
892 if ! test -x "$git_bin_dir/git"
893 then
894 if test -z "$with_dashes"
895 then
e4597aae
MO
896 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
897 fi
898 with_dashes=t
899 fi
900 PATH="$git_bin_dir:$PATH"
6cec5c68 901 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
902 if test -n "$with_dashes"
903 then
6cec5c68 904 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 905 fi
4e1be63c 906fi
6cec5c68 907GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 908GIT_CONFIG_NOSYSTEM=1
3c995beb 909GIT_ATTR_NOSYSTEM=1
8f323c00 910export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 911
5e87eae9
JH
912if test -z "$GIT_TEST_CMP"
913then
914 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
915 then
916 GIT_TEST_CMP="$DIFF -c"
917 else
918 GIT_TEST_CMP="$DIFF -u"
919 fi
920fi
921
6cec5c68 922GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 923export GITPERLLIB
6cec5c68 924test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
925 error "You haven't built things yet, have you?"
926}
e1970ce4 927
e6e7530d 928if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
1c0cc756 929then
56cf9806 930 echo >&2 'You need to build test-chmtime:'
e6e7530d 931 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
56cf9806
EW
932 exit 1
933fi
934
e1970ce4 935# Test repository
002d4ce8
JK
936TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
937test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
938case "$TRASH_DIRECTORY" in
939/*) ;; # absolute path is good
940 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 941esac
38b074de 942rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 943 GIT_EXIT_OK=t
8d14ac94
JH
944 echo >&5 "FATAL: Cannot prepare test area"
945 exit 1
946}
947
90cff968 948HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
949GNUPGHOME="$HOME/gnupg-home-not-used"
950export HOME GNUPGHOME
90cff968 951
1c0cc756
RJ
952if test -z "$TEST_NO_CREATE_REPO"
953then
38b074de 954 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 955else
38b074de 956 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 957fi
1bd9c648
LW
958# Use -P to resolve symlinks in our working directory so that the cwd
959# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 960cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 961
d5d9de1b
JS
962this_test=${0##*/}
963this_test=${this_test%%-*}
e6a6ddc9
TR
964if match_pattern_list "$this_test" $GIT_SKIP_TESTS
965then
966 say_color info >&3 "skipping test $this_test altogether"
967 skip_all="skip all tests in $this_test"
968 test_done
969fi
f17e9fbb 970
8648732e
BC
971# Provide an implementation of the 'yes' utility
972yes () {
973 if test $# = 0
974 then
975 y=y
976 else
977 y="$*"
978 fi
979
6129c930
JS
980 i=0
981 while test $i -lt 99
8648732e 982 do
6129c930
JS
983 echo "$y"
984 i=$(($i+1))
8648732e
BC
985 done
986}
987
f17e9fbb 988# Fix some commands on Windows
d98b2c5f
JS
989uname_s=$(uname -s)
990case $uname_s in
f17e9fbb
JS
991*MINGW*)
992 # Windows has its own (incompatible) sort and find
993 sort () {
994 /usr/bin/sort "$@"
995 }
996 find () {
997 /usr/bin/find "$@"
998 }
4114156a
JS
999 # git sees Windows-style pwd
1000 pwd () {
1001 builtin pwd -W
1002 }
ee9fb68c 1003 # no POSIX permissions
6fd1106a 1004 # backslashes in pathspec are converted to '/'
fb9a2bea 1005 # exec does not inherit the PID
a94114ad 1006 test_set_prereq MINGW
5f4e02e5 1007 test_set_prereq NATIVE_CRLF
a31d0665 1008 test_set_prereq SED_STRIPS_CR
97669eed 1009 test_set_prereq GREP_STRIPS_CR
4d715ac0 1010 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1011 ;;
1012*CYGWIN*)
1013 test_set_prereq POSIXPERM
a31d0665 1014 test_set_prereq EXECKEEPSPID
cfa96496 1015 test_set_prereq CYGWIN
a31d0665 1016 test_set_prereq SED_STRIPS_CR
97669eed 1017 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1018 ;;
1019*)
1020 test_set_prereq POSIXPERM
6fd1106a 1021 test_set_prereq BSLASHPSPEC
fb9a2bea 1022 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1023 ;;
1024esac
704a3143 1025
b082687c 1026( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1027test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1028test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1029test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1030test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
5e9637c6 1031test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1032
bb946bba 1033# Can we rely on git's output in the C locale?
30955229
JN
1034if test -n "$GETTEXT_POISON"
1035then
1036 GIT_GETTEXT_POISON=YesPlease
1037 export GIT_GETTEXT_POISON
5e9637c6 1038 test_set_prereq GETTEXT_POISON
30955229
JN
1039else
1040 test_set_prereq C_LOCALE_OUTPUT
1041fi
bb946bba 1042
cabdee2c
JH
1043# Use this instead of test_cmp to compare files that contain expected and
1044# actual output from git commands that can be translated. When running
1045# under GETTEXT_POISON this pretends that the command produced expected
1046# results.
1047test_i18ncmp () {
1048 test -n "$GETTEXT_POISON" || test_cmp "$@"
1049}
1050
127df8c6
JH
1051# Use this instead of "grep expected-string actual" to see if the
1052# output from a git command that can be translated either contains an
1053# expected string, or does not contain an unwanted one. When running
1054# under GETTEXT_POISON this pretends that the command produced expected
1055# results.
1056test_i18ngrep () {
1057 if test -n "$GETTEXT_POISON"
1058 then
1059 : # pretend success
1060 elif test "x!" = "x$1"
1061 then
1062 shift
1063 ! grep "$@"
1064 else
1065 grep "$@"
1066 fi
1067}
1068
20073274
AS
1069test_lazy_prereq PIPE '
1070 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1071 test_have_prereq !MINGW,!CYGWIN &&
1072 rm -f testfifo && mkfifo testfifo
20073274
AS
1073'
1074
04083f27
JH
1075test_lazy_prereq SYMLINKS '
1076 # test whether the filesystem supports symbolic links
1077 ln -s x y && test -h y
1078'
c91cfd19 1079
b018c735
JN
1080test_lazy_prereq FILEMODE '
1081 test "$(git config --bool core.filemode)" = true
1082'
1083
ac39aa61
MG
1084test_lazy_prereq CASE_INSENSITIVE_FS '
1085 echo good >CamelCase &&
1086 echo bad >camelcase &&
1087 test "$(cat CamelCase)" != good
1088'
1089
5b0b5dd4
MG
1090test_lazy_prereq UTF8_NFD_TO_NFC '
1091 # check whether FS converts nfd unicode to nfc
1092 auml=$(printf "\303\244")
1093 aumlcdiar=$(printf "\141\314\210")
1094 >"$auml" &&
1095 case "$(echo *)" in
1096 "$aumlcdiar")
1097 true ;;
1098 *)
1099 false ;;
1100 esac
1101'
1102
09feffb6
JK
1103test_lazy_prereq AUTOIDENT '
1104 sane_unset GIT_AUTHOR_NAME &&
1105 sane_unset GIT_AUTHOR_EMAIL &&
1106 git var GIT_AUTHOR_IDENT
1107'
1108
6219bb22
JH
1109test_lazy_prereq EXPENSIVE '
1110 test -n "$GIT_TEST_LONG"
1111'
1112
e1ecd9e3
JH
1113test_lazy_prereq USR_BIN_TIME '
1114 test -x /usr/bin/time
1115'
1116
1767c517
JK
1117test_lazy_prereq NOT_ROOT '
1118 uid=$(id -u) &&
1119 test "$uid" != 0
1120'
1121
63b747ce
JT
1122test_lazy_prereq JGIT '
1123 type jgit
1124'
1125
719c3da2
JH
1126# SANITY is about "can you correctly predict what the filesystem would
1127# do by only looking at the permission bits of the files and
1128# directories?" A typical example of !SANITY is running the test
1129# suite as root, where a test may expect "chmod -r file && cat file"
1130# to fail because file is supposed to be unreadable after a successful
1131# chmod. In an environment (i.e. combination of what filesystem is
1132# being used and who is running the tests) that lacks SANITY, you may
1133# be able to delete or create a file when the containing directory
1134# doesn't have write permissions, or access a file even if the
1135# containing directory doesn't have read or execute permissions.
1136
f400e51c
TB
1137test_lazy_prereq SANITY '
1138 mkdir SANETESTD.1 SANETESTD.2 &&
1139
1140 chmod +w SANETESTD.1 SANETESTD.2 &&
1141 >SANETESTD.1/x 2>SANETESTD.2/x &&
1142 chmod -w SANETESTD.1 &&
719c3da2 1143 chmod -r SANETESTD.1/x &&
f400e51c
TB
1144 chmod -rx SANETESTD.2 ||
1145 error "bug in test sript: cannot prepare SANETESTD"
1146
719c3da2 1147 ! test -r SANETESTD.1/x &&
f400e51c
TB
1148 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1149 status=$?
1150
1151 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1152 rm -rf SANETESTD.1 SANETESTD.2 ||
1153 error "bug in test sript: cannot clean SANETESTD"
1154 return $status
1155'
f838ce58 1156
d98b2c5f 1157test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1158GIT_UNZIP=${GIT_UNZIP:-unzip}
1159test_lazy_prereq UNZIP '
1160 "$GIT_UNZIP" -v
1161 test $? -ne 127
1162'
9a308de3
JK
1163
1164run_with_limited_cmdline () {
1165 (ulimit -s 128 && "$@")
1166}
1167
21dac1de
RJ
1168test_lazy_prereq CMDLINE_LIMIT '
1169 test_have_prereq !MINGW,!CYGWIN &&
1170 run_with_limited_cmdline true
1171'
6b9c38e1 1172
4db464f8
MG
1173run_with_limited_stack () {
1174 (ulimit -s 128 && "$@")
1175}
1176
21dac1de
RJ
1177test_lazy_prereq ULIMIT_STACK_SIZE '
1178 test_have_prereq !MINGW,!CYGWIN &&
1179 run_with_limited_stack true
1180'
4db464f8 1181
6b9c38e1
JK
1182build_option () {
1183 git version --build-options |
1184 sed -ne "s/^$1: //p"
1185}
1186
1187test_lazy_prereq LONG_IS_64BIT '
1188 test 8 -le "$(build_option sizeof-long)"
1189'
a07fb050
JS
1190
1191test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
efac8ac8 1192test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'